/*
             CREATOR: DAn williams
                DATE:
         DESCRIPTION:
            FILENAME:    .c
             STARTED:
    OPERATING SYSTEM: Linux
1st VERSION FINISHED:



*/


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

//global variables

#define REPLYSZ       512
#define MAX(a,b)    (((a) > (b)) ? (a) : (b))

void chomp(char * string);
void stateCounter (int factors, int * states, int * stateItter, char ** factorNames, char *** stateNames, unsigned int ittercount);

int main(int argc, char** argv)
{
  // local variables
  
  int retcode;
  
  char reply[REPLYSZ];
  char * string;
    
  int factors;
  int * states;
  int * stateItter;
  int * maxNameLen;
  
  char **  factorNames;
  char ***  stateNames;
  
  int i, j, k;
  
  retcode     = 0;
  factorNames = NULL;
  stateNames  = NULL;
  
  printf(" This program combines inputs \n");
  printf(" Written by Dan Williams jan 15 2006 \n");
  
  
  factors = 0;
  do { 
    printf("Enter a factor name or press enter when done\n");
    string=fgets(reply,REPLYSZ,stdin);
    chomp(string);
    if (strlen(string) != 0) {
       factors++;       
       factorNames = realloc(factorNames, (sizeof(char*)*factors));
       factorNames[factors-1] = strdup(string);       
    }
  } while (strlen(string) != 0);  
 
  printf("Now to get the states for the factors...\n");
  states     = malloc( sizeof(int)*factors );
  stateItter = malloc( sizeof(int)*factors );
  maxNameLen = malloc( sizeof(int)*factors );
  stateNames = malloc( sizeof(char**)*factors );


  
  for(i = 0; i < factors; i++) {
    states[i] = 0;    
    do { 
      printf("Enter a state name for factor %s or press enter for next\n",  factorNames[i]);
      string=fgets(reply,REPLYSZ,stdin);
      chomp(string);
      if (strlen(string) != 0) {         
         states[i]++;       
         stateNames[i] = realloc(stateNames[i], (sizeof(char*)*states[i]));
         stateNames[i][states[i]-1] = strdup(string);       
      }
    } while (strlen(string) != 0);  
   }
   
   
   
   
   // count how many bits for our state addresses and count string lengths
   k = 0;   
   for(i = 0; i < factors; i++) {
     for (j = 0; (1<<j)<states[i]; j++);     
     printf("// %d bits for the %s factor\n", j, factorNames[i]);
     k += j;
   }
   printf("// total of %d bits in the state address\n", k);
   
     //realloc factor strings to normalize length
   for(i = 0; i < factors; i++) {
     maxNameLen[i]=0;
     for (j = 0; j < states[i]; j++) {     
       maxNameLen[i] = MAX(strlen(stateNames[i][j]), maxNameLen[i]);;              
     }
   }
   //realloc factor strings to normalize length
   for(i = 0; i < factors; i++) {
     for (j = 0; j < states[i]; j++) {
       stateNames[i][j] = realloc (stateNames[i][j], maxNameLen[i]+1);
       stateNames[i][j][maxNameLen[i]] = '\0';
       memset(
           stateNames[i][j] + strlen(stateNames[i][j]) ,
           ' ',
           maxNameLen[i]-(strlen(stateNames[i][j]) - 1)
       );              
     }
   }
   
   // write us up a struct
   printf("typedef struct FSM_State_s { \n");
   k = 0;
   for(i = 0; i < factors; i++) {
     for (j = 0; (1<<j)<states[i]; j++);
     printf("  unsigned %s : %d;\n", factorNames[i], j);
     k += j;
   }
   printf("} FSM_State_t;\n");
  
  
   printf(" \n\
typedef unsigned int  PTRType; \n\
    \n\
typedef struct stateEntry_s {  \n\
    PTRType       next;            \n\
    FSM_State_t   state;           \n\
 } stateEntry_t;                   \n\
 \n");

  
   // make C code for enumerating things
   for(i = 0; i < factors; i++) {   
    //printf ("#define %s  %d\n", factorNames[i], i);
    printf ("//----------| %s |----------\n", factorNames[i]);
    for (j = 0; j < states[i]; j++) {
      
      printf ("  #define %s %d\n", stateNames[i][j], j) ;
    }   
   }
  

  
     printf("//------------\n  //  ");
   for(i = 0; i < factors; i++) {
    printf ("  %s  ,", factorNames[i]);   
    stateItter[i] = 0;
   }
   printf("\n");

   
   printf("stateEntry_t stateTable[] = {   \n");
   stateCounter (factors, states, stateItter, factorNames, stateNames, 0);
   printf("};");
  
  return(retcode);
}


//  recursion hurts my brain....
void stateCounter (int factors, int * states, int * stateItter, char ** factorNames, char *** stateNames, unsigned int ittercount) {

   int i;

   printf("{ 0, {"); 
   for(i = 0; i < factors; i++) {
    printf (" %s  ,", stateNames[i][stateItter[i]]);       
   }
   printf("    }}  /*   index: %u   */",ittercount); 
   printf("\n");
   
   for(i = 0; i < factors; i++) {
     stateItter[i]++;
     if (stateItter[i] < states[i]) {
        break;
     }
     stateItter[i] = 0;
   }
   if (i == factors) {
     return;
   } else {
     stateCounter (factors, states, stateItter, factorNames, stateNames, ittercount+1);
   }

}


//subroutines

void chomp(char * string) {
  char * target;
  
  target = strchr(string,'\n');
  if (target != NULL) { *target = '\0'; }
  
}



/*

FSMState:FSMnextptr


#define factor1State1   value
#define factor1State2   value

Take a bitpattern table

typedef struct stepper4ph_s {      
      unsigned Port       :3;
      unsigned MotorNum   :1;
      unsigned State      :3;
      unsigned Direction  :1;
} stepper4ph_t;

double it, half for last state, half for next state

typedef struct stateEntry_s {
   stepper4ph_t   curr;
   stepper4ph_t   next;   
} stateEntry_t;


  stateEntry_t stateTable[] = {  
  
      
      (3)+(b0001<<4),                    
      (0)+(b0010<<4),
      (1)+(b0100<<4),
      (2)+(b1000<<4)
   };  


*/
