#include "state.h"

Accumulator::Accumulator() {
  names = NULL;
  items = 0;
}

void Accumulator::Add( const char * s) {
  names = (char **)realloc(names, sizeof(char*)*(++items));
  names[items-1] = strdup(s);
}

char * Accumulator::Get(int i) {
  if (i < items) {
    return names[i];
  } else {
    return NULL;
  }
}

void Accumulator::Rename(int i, const char * s) {
  if (i < items) {
    free(names[i]); 
    names[i] = strdup(s);
  }
}

void Accumulator::Delete(int i) {
  if (i < items) {
    free(names[i]); 
    for(int j= i; j < (items); j++) {
      names[j] = names[j+1];
    }
    names = (char **)realloc(names, sizeof(char*)*(--items));
  }
}
